/*
	PIC18F2550 `USB + DIOx[X{[hpLEDC~l[VTv
		ver1.00	2011/06/12		
*/

#include <p18f2550.h>
#include <stdlib.h>
#include <timers.h>
#include <delays.h>
#include "bootload.h"
#include "asv_io.h"


#define LED_DUTY_MAX			100	//duty̍ōl
#define MAIN_ROUTINE_CYCLE_TIME_INIT	4	//C[`̃TCN^C
		//Delay10KTCYx̒lŌvZ
		//Delay10KTCYx1̎Ԃ(4/48000000Hz)*10000 = 1/1200s
		//12*1/1200s = 10ms
#define MAIN_ROUTINE_CYCLE_TIME_MAX	24
#define MAIN_ROUTINE_CYCLE_TIME_MIN	1

#define WRITE_TIMER0_COUNT	0x6A	//Timer0̎
		//	48MHzA0.0001sɊ荞݂𔭐
		//	0.0001 / (4 / 48000000) / 8 = 150
		//	256 - 150 = 106 = 0x6A

//XCb`̓`^Oh~p
#define SW_COUNT_INIT	10

//O[oϐ錾
unsigned char led_duty[8] = {0,0,0,0,0,0,0,0};	//LEDdutyݒ(0ŏA100őS)
unsigned char led_duty_count = 0;	//led_pduty̓l


//LED_p^[
int unsigned led_put_counter = 0;
void (*led_put_pattern)(void);
void led_put_pattern1(void);
void led_put_pattern2(void);
void led_put_pattern3(void);
void led_put_pattern4(void);
void led_put_pattern5(void);
void led_put_pattern6(void);
void led_put_pattern7(void);
void led_put_pattern8(void);

char main_routine_cycle_time = MAIN_ROUTINE_CYCLE_TIME_INIT;

//XCb`̓`^Oh~
char sw9_count = 0;
char sw10_count = 0;

//	ʃx荞݂͂ɏ܂
//	֐ςĂ͂܂
void isr_high()
{
	char fi;

	if(INTCONbits.TMR0IF == 1)
	{
		INTCONbits.TMR0IF = 0;
		WriteTimer0(WRITE_TIMER0_COUNT);

		led_duty_count++;
		if(led_duty_count >= LED_DUTY_MAX)
			led_duty_count = 0;

		for(fi = 0;fi<8;fi++)
		{
			(led_duty_count >= led_duty[fi]) ? asv_io_set_LED((fi+1),0) : asv_io_set_LED((fi+1),1);
		}
	}
}

//	ʃx荞݂͂ɏ܂
//	֐ςĂ͂܂
void isr_low()
{
}

//	ʏ̏珑܂
void main(void)
{	
//	ASOOVU USBfW^o̓Lbgp̂̏
	asv_io_init();

	led_put_pattern = led_put_pattern1;	//ŏ̓p^[P

//	^C}0̐ݒ
	OpenTimer0(TIMER_INT_ON & T0_8BIT & T0_SOURCE_INT & T0_PS_1_8);
	WriteTimer0(WRITE_TIMER0_COUNT);

//	荞݊Jn
	RCONbits.IPEN = 1;			//荞ݗDt
	INTCON2bits.TMR0IP = 1;		//^C}0ʃx荞݂ɐݒ
	INTCONbits.TMR0IE = 1;		//^C}0荞݋
	INTCONbits.GIEH = 1;		//ʃx荞݂̋

	
	while(1)
	{
		if(sw9_count != 0)
			sw9_count--;
		if(asv_io_get_SW(9) == 0)
		{
			sw9_count = SW_COUNT_INIT;
		}
		else if(sw9_count == (SW_COUNT_INIT - 1))
		{
			if(main_routine_cycle_time < MAIN_ROUTINE_CYCLE_TIME_MAX)
				main_routine_cycle_time++;
		}

		if(sw10_count != 0)
			sw10_count--;
		if(asv_io_get_SW(10) == 0)
		{
			sw10_count = SW_COUNT_INIT;
		}
		else if(sw10_count == (SW_COUNT_INIT - 1))
		{
			if(main_routine_cycle_time > MAIN_ROUTINE_CYCLE_TIME_MIN)
				main_routine_cycle_time--;
		}

		if(asv_io_get_SW(1) == 0)	led_put_pattern = led_put_pattern1;
		if(asv_io_get_SW(2) == 0)	led_put_pattern = led_put_pattern2;
		if(asv_io_get_SW(3) == 0)	led_put_pattern = led_put_pattern3;
		if(asv_io_get_SW(4) == 0)	led_put_pattern = led_put_pattern4;
		if(asv_io_get_SW(5) == 0)	led_put_pattern = led_put_pattern5;
		if(asv_io_get_SW(6) == 0)	led_put_pattern = led_put_pattern6;
		if(asv_io_get_SW(7) == 0)	led_put_pattern = led_put_pattern7;
		if(asv_io_get_SW(8) == 0)	led_put_pattern = led_put_pattern8;

		(*led_put_pattern)();

		Delay10KTCYx(main_routine_cycle_time);
	}
}


